/*
 * Part of the GaBIEn project.
 * (Graphics and Basic Input Engine)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package gabien.ui;


import gabien.IGrInDriver;
import gabien.IGrInDriver.IImage;

/**
 *
 * @author matt
 */
public class UIButton extends UIElement {
    public IImage buttonImage;
    public int imageX,imageY;
    public Runnable onClick;
    public double pressedTime=0;
    @Override
    public void updateAndRender(int ox, int oy,double DeltaTime,boolean selected, IGrInDriver igd) {
        if (pressedTime>0)
        {
            pressedTime-=DeltaTime;
        }
        igd.blitImage(imageX, imageY, elementBounds.width, elementBounds.height, ox, oy+(pressedTime>0?4:0), buttonImage);
    }

    @Override
    public void handleClick(int x, int y,int button) {
    	if (button==1)
    	{
        onClick.run();
        pressedTime=0.5;
    	}
    }
    
}
