/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.blocks;

import javachan.GameState;
import gabien.IGrInDriver;
import gabien.ui.Rect;
import javachan.IPhysicsObject;

/**
 * The root of all block types.
 * @author matt
 */
public class BasicBlockType {
    //ThisIsIkachan:(gs==ipo)
    //0:Left,1:Right,2:Up,3:Down
    public void handleHardCollision(int x,int y,GameState gs,IPhysicsObject ipo,int direction)
    {
    }
    //This is a collision that doesn't stop Ikachan(or other physics objects).
    //Thus,direction calculations aren't run.
    public void handleSoftCollision(int x,int y,GameState gs,IPhysicsObject ipo)
    {
    }
    public int getAmountOfSubTypes(IGrInDriver igd)
    {
        return igd.getImage(getBlockImage(), 0, 0, 0).getWidth()/16;
    }
    protected String getBlockImage()
    {
        return "Pbm/PrtBlock.pbm";
    }
    //Does colliding with this halt Ikachan?
    public boolean collisionStops()
    {
        return true;
    }
    //Area of collision.
    public Rect getCollision(int x,int y,int subtype)
    {
        return new Rect(x*16,y*16,16,16);
    }
    //Draws this block at a specific pixel position.Note that pass is 0 or 1(0 is back,1 is fore)
    public void doRender(int pass,int ox,int oy,int subtype,IGrInDriver igd,double Time)
    {
        if (pass!=0) return;
        igd.blitBCKImage(16*subtype, 0, 16, 16, ox, oy, igd.getImage(getBlockImage(), 0, 0, 0));
    }
}
