/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */

package javachan.games;

import java.io.IOException;

import gabien.GaBIEn;
import gabien.IGrInDriver;
import gabien.IGrInDriver.IImage;
import javachan.Game;
import javachan.IGame;
import gabien.music.PiyoPiyoPlayingSample;

public class LauncherGame implements IGame {
    int opt = 0;

    @Override
    public void doUpdate(double DeltaTime, double Time, Game g) {
        opt = g.graphics.getMouseY() / 32;
        if (g.graphics.isKeyDown(IGrInDriver.VK_E)) {
            opt = 2;
        }
        if (g.graphics.getMouseJustDown()
                || g.graphics.isKeyDown(IGrInDriver.VK_ENTER)) {
            int w = 320;
            int h = 240;
            if (opt == 1) {
                w = 800;
                h = 600;
            }

            g.graphics.Shutdown();
            g.graphics = GaBIEn.makeGrIn("Ikachan Map Editor v"
                    + Game.SYSTEM_VERSION + "." + Game.SYSTEM_VERSION_MINOR, w, h);
            if (opt == 2) {
                try {
                    PiyoPiyoPlayingSample.ensureAllSamplesLoaded();
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
                GaBIEn.timeDelta(true);
            }
            g.resetGame(opt != 2);
        }
        if (opt < 0)
            opt = 2;
        if (opt > 2)
            opt = 0;
        g.graphics.clearAll(0, 0, 0);
        int c = 0;
        c = opt == 0 ? 32 : 40;
        // OptNum,BigRes,Experiment,VposRadioButton
        showOption(0, false, false, c, g);
        c = opt == 1 ? 32 : 40;
        showOption(1, true, false, c, g);
        c = opt == 2 ? 32 : 40;
        showOption(2, false, true, c, g);
        g.graphics.flush();
    }

    private void showOption(int i, boolean br, boolean ex, int c2, Game g) {
        IImage edit = g.graphics.getImage("TileEditor.png", 0, 0, 0);
        int y = i * 32;
        g.graphics.blitBCKImage(280, c2, 8, 8, 0, y + 12, edit);
        g.graphics.blitBCKImage(288, 16 + (br ? 8 : 0), 32, 8, 16, y + 4, edit);
        if (ex) {
            g.graphics.blitBCKImage(288, 32, 32, 16, 16, y + 12, edit);
        } else {
            g.graphics.blitBCKImage(224, 32, 56, 16, 16, y + 12, edit);
        }

    }
}
