/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.npcs;

import javachan.GameState;
import javachan.GameStateNPChar;
import javachan.GameStateNPChar.NPCCharacter;
import javachan.IEventCallback;
import gabien.IGrInDriver;
import gabien.IGrInDriver.IImage;
import gabien.ui.Rect;

/**
 *
 * @author matt
 */
public class BasicNPCType {
    public int drawSizeX = 16, drawSizeY = 16, drawOfsX = 0, drawOfsY = 0;

    public Rect GetRectangle(GameStateNPChar.NPCCharacter In) {
        return new Rect((int) (In.posX * 16) + 1, (int) (In.posY * 16) + 1, 14, 14);
    }

    public void HitWorld(GameStateNPChar.NPCCharacter In, int bdir) {
    }

    /**
     * Reducing the insane code duplication problem and keeping the architecture
     * closer to Ikachan's at the same time.
     */
    public String[] npcImg = { "Pbm/Hari.pbm", "Pbm/Isogin.pbm", "Pbm/Kani.pbm", "Pbm/Sleep.pbm", "Pbm/Chibi.pbm", "Pbm/Hoshi.pbm", "Pbm/Dum.pbm", "Pbm/Carry.pbm", "Pbm/Juel.pbm", "Pbm/Ufo.pbm" };

    public void doRender(int px, int py, double Time, GameStateNPChar.NPCCharacter In, IGrInDriver graphics) {
        int Type = In.entityType;
        IImage npci = graphics.getImage(npcImg[In.entityType], 0, 0, 0);
        if (npci == null) {
            System.out.println("BAD NPCTYPE " + Type);
        } else {
            graphics.blitBCKImage(((int) (In.displayX) * drawSizeX)%npci.getWidth(), ((int) (In.displayY) * drawSizeY)%npci.getHeight(), drawSizeX, drawSizeY, (int) (In.posX * 16) + px + drawOfsX, (int) (In.posY * 16) + py + drawOfsY, npci);
        }
    }

    public void doEditorTick(GameStateNPChar.NPCCharacter npc) {
        // Needed to ensure type-changing updates stuff correctly
        npc.displayX = 0;
        npc.displayY = 0;
    }

    public void doTick(NPCCharacter npc, GameState gs, double Time) {

    }

    protected void hurtEnemy(GameState gs, NPCCharacter In, IEventCallback iec) {
        gs.applyXPEnergy(rewardXP(), 0);
        In.exists = false;
        if (In.collisionType == 2)
            iec.startEvent(In.eventID);
    }

    // -1:Not needed,0:Left,1:Right,2:Up,3:Down

    public void ikachanTouchedEnemy(NPCCharacter In, GameState gs, int r, IEventCallback iec) {
        if (r == 3) {
            if (gs.hasItem(1)) {
                if (gs.playerLevel >= levelToHurt()) {
                    hurtEnemy(gs, In, iec);
                } else {
                    // TODO:Sound:Bounced off!
                }
            }
            // Ikachan's response to attack attempts without the spike hat is:
            // do nothing.
        }
        if (In.touchWillHurt!=0) {
            gs.applyXPEnergy(0, -touchDamage(In));
        }

    }

    protected int touchDamage(NPCCharacter npc) {
        return 0;
    }

    protected int levelToHurt() {
        return 0;
    }

    protected int rewardXP() {
        return 0;
    }
}
